!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.vueMarkText=t():e.vueMarkText=t()}(self,(function(){return(()=>{var e={517:(e,t,n)=>{var r=n(15),s=n(645)(r);s.push([e.id,"\n.marked-text[data-v-909d61e4] {\n  text-align: left;\n  margin-top: 30px;\n  margin-bottom: 30px;\n  margin-left: auto;\n  margin-right: auto;\n  padding: 10px 10px;\n  border-radius: 10px;\n  width: calc(90% - 2*30px - 2*10px - 2*5px);\n  height: calc(100% - 2*30px - 2*10px - 2*5px);\n  overflow-y: auto;\n  word-wrap: break-word;\n  white-space: pre-wrap;\n  position: relative;\n  z-index: 1;\n}\n\n","",{version:3,sources:["webpack://./src/MarkedText.vue"],names:[],mappings:";AAyTA;EACE,gBAAgB;EAChB,gBAAgB;EAChB,mBAAmB;EACnB,iBAAiB;EACjB,kBAAkB;EAClB,kBAAkB;EAClB,mBAAmB;EACnB,0CAA0C;EAC1C,4CAA4C;EAC5C,gBAAgB;EAChB,qBAAqB;EACrB,qBAAqB;EACrB,kBAAkB;EAClB,UAAU;AACZ",sourcesContent:["<template>\n<p class=\"marked-text\" @mouseup=\"event => controller.onMouseUpOther(event)\">\n  <DepotRenderer\n    :spanBatches=\"spanBatches\"\n    :spanDataToStyles=\"spanDataToStyles\"\n    @trigger=\"spanDataTrigger\"\n  />\n</p>\n</template>\n\n\n\n<script lang='ts'>\nimport chroma from 'chroma-js'\nimport { Component, defineComponent, PropType } from 'vue'\n\nimport DepotRenderer from './DepotRenderer.vue'\n\nimport IMarkedText from './IMarkedText'\nimport IController from './IController'\nimport Manuscript from './Manuscript'\nimport IMark from './IMark'\nimport SpanData, { SpanControllerCbk } from './SpanData'\nimport Subject, { SubjectStyleType } from './Subject'\n\n\nconst MarkedText: Component<IMarkedText> = defineComponent({\n\n  name: 'VueMarkedText',\n\n  components: {\n    DepotRenderer\n  },\n\n  props: {\n    sourceText: {\n      type: String,\n      required: true\n    },\n    marks: {\n      type: Array as PropType<IMark[]>,\n      required: true\n    },\n    controller: {\n      type: Object as PropType<IController>,\n      required: true\n    },\n    batchSize: {\n      type: Number,\n      default: 20\n    },\n    numSubjectColors: {\n      type: Number,\n      default: 8\n    },\n    subjectColorLightness: {\n      type: Number,\n      default: 1.0\n    },\n    subjectStyleType: {\n      type: String as PropType<SubjectStyleType>,\n      default: 'border'\n    },\n    showBatches: {\n      type: Boolean,\n      default: false\n    }\n  },\n\n  data() {\n    const manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize)\n    const colors: string[] = []\n    const activeSubjectNames = new Set<string>()\n    const subjectGlossary = new Map<string, Subject>()\n    return {\n      manuscript,\n      colors,\n      activeSubjectNames,\n      subjectGlossary\n    }\n  },\n\n  computed: {\n    spanBatches(): SpanData[][] {\n      return this.manuscript.spanBatches\n    }\n  },\n\n  watch: {\n    sourceText() {\n      this.manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize)\n      this.resetSpans()\n    },\n    marks: {\n      handler(newMarks: IMark[]) {\n        this.manuscript.changeMarks(newMarks)\n        this.resetSubjects()\n      },\n      deep: true\n    },\n    controller(newController: IController, oldController: IController) {\n      oldController.unlink()\n      newController.link(this)\n    },\n    batchSize(val: number) {\n      this.manuscript.batchSize = val\n      this.manuscript.resetSpans()\n    },\n    colorOptions() {\n      this.resetSubjects(false)\n      this.$forceUpdate()\n    },\n    subjectStyleType() {\n      this.resetSubjects(false)\n      this.$forceUpdate()\n    },\n    showBatches(val: boolean) {\n      if (val) this.metaStringDivideBatches()\n      else this.removeMetaStrings()\n    }\n  },\n\n  methods: {\n\n    generateColors() {\n\n      // Create a color scale with the desired brightness\n      const spectrum = chroma.scale(\n        [ 'ff0000', 'ffff00', '00ff00', '00ffff', '0000ff', 'ff00ff', 'ff0000' ].map(\n          colorStr => chroma.hex(colorStr).hsl()\n        ).map(\n          hcl => chroma.hsl(hcl[0], hcl[1], hcl[2] * this.subjectColorLightness)\n        )\n      )\n\n      let colors = spectrum.colors(this.numSubjectColors + 1).slice(0, this.numSubjectColors)\n\n      // Mix it up a bit more & get different colors earlier.\n      // Find a non-divisor to go to next color by about a 6th\n      let diff = Math.max(Math.round(colors.length / 6.0), 1)\n      while (diff > 1 && colors.length % diff === 0) diff -= 1\n      if (diff === 1) return colors\n\n      const newColors = colors.slice()\n      let idx = 0\n      for (const color of colors) {\n        newColors[idx] = color\n        idx += diff\n        if (idx >= newColors.length) idx -= newColors.length\n      }\n      return newColors\n    },\n\n    spanDataToStyles(spanData: SpanData) {\n      return spanData.subjects.map(\n        subject => this.subjectGlossary.get(subject)\n      ).filter(\n        subject => subject != null && subject.active\n      ).map(\n        subject => (subject as Subject).style\n      )\n    },\n\n    spanDataTrigger(payload: { rawEvent: Event, spanData: SpanData, spanControllerEvent: SpanControllerCbk }) {\n      payload.spanControllerEvent(payload.rawEvent, payload.spanData, this.controller)\n    },\n\n\n    resetSpans() {\n      this.manuscript.resetSpans()\n      this.resetSubjects()\n    },\n\n    resetSubjects(resetActive: boolean = true) {\n\n      this.subjectGlossary.clear()\n      const subjectNames = new Set(\n        Array<string>().concat(...this.marks.map(mark => mark.subjects))\n      )\n      let colorIdx = 0\n      const colorMod = this.colors.length\n      for (const subjectName of subjectNames) {\n        this.subjectGlossary.set(subjectName, new Subject(\n          this,\n          subjectName,\n          this.colors[colorIdx],\n          this.subjectStyleType\n        ))\n        colorIdx = (colorIdx + 1) % colorMod\n      }\n\n      if (resetActive) this.activeSubjectNames = new Set(this.subjectGlossary.keys())\n      else {\n        for (const [subjectName, subject] of this.subjectGlossary.entries()) {\n          if (!this.activeSubjectNames.has(subjectName)) subject.active = false\n        }\n      }\n\n    },\n\n\n    resetSelection() {\n      this.manuscript.selection = null\n    },\n\n    setSelection(begChar: number, endChar: number) {\n      this.manuscript.selection = [begChar, endChar]\n    },\n\n    getSelection() {\n      return this.manuscript.selection\n    },\n\n\n    subjectColor(subjectName: string) {\n      return this.subjectGlossary.get(subjectName)?.color\n    },\n    subjectStyle(subjectName: string) {\n      return this.subjectGlossary.get(subjectName)?.style\n    },\n\n    activateSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.active = true\n      this.activeSubjectNames.add(subjectName)\n      this.$forceUpdate()\n    },\n    deactivateSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.active = false\n      this.activeSubjectNames.delete(subjectName)\n      this.$forceUpdate()\n    },\n    toggleSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) {\n        if (subject.active) this.deactivateSubject(subjectName)\n        else this.activateSubject(subjectName)\n      }\n    },\n    activateAllSubjects() {\n      this.subjectGlossary.forEach(subject => { subject.active = true })\n      this.activeSubjectNames = new Set(this.subjectGlossary.keys())\n      this.$forceUpdate()\n    },\n    deactivateAllSubjects() {\n      this.subjectGlossary.forEach(subject => { subject.active = false })\n      this.activeSubjectNames = new Set()\n      this.$forceUpdate()\n    },\n\n    lineConnectSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.lineConnect()\n    },\n    lineDisconnectSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.lineDisconnect()\n    },\n    toggleLines(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.toggleLines()\n    },\n\n\n    metaStringEncloseSections(begSections: number[], endSections: number[]) {\n\n      const metaChars = Array(\n        ...begSections.map(idx => ['[', idx] as [string, number]),\n        ...endSections.map(idx => [']', idx] as [string, number]),\n      )\n\n      this.manuscript.setMetaStrings(metaChars)\n\n    },\n\n    metaStringDivideBatches() {\n\n      const metaChars = Array(...this.spanBatches.filter(\n        batch => batch.length > 0\n      ).map(\n        batch => ['|', batch[0].charRange[0]] as [string, number]\n      ))\n\n      this.manuscript.setMetaStrings(metaChars)\n\n    },\n\n    removeMetaStrings() {\n      this.manuscript.setMetaStrings([])\n    }\n\n  },\n\n  beforeMount() {\n    this.colors = this.generateColors()\n    this.controller.link(this)\n    this.resetSpans()\n  },\n\n  beforeUnmount() {\n    this.controller.unlink()\n  }\n\n})\n\nexport default MarkedText\n<\/script>\n\n\n\n<style scoped>\n\n.marked-text {\n  text-align: left;\n  margin-top: 30px;\n  margin-bottom: 30px;\n  margin-left: auto;\n  margin-right: auto;\n  padding: 10px 10px;\n  border-radius: 10px;\n  width: calc(90% - 2*30px - 2*10px - 2*5px);\n  height: calc(100% - 2*30px - 2*10px - 2*5px);\n  overflow-y: auto;\n  word-wrap: break-word;\n  white-space: pre-wrap;\n  position: relative;\n  z-index: 1;\n}\n\n</style>\n\n\n<style>\n\n.leader-line {\n  z-index: 0;\n}\n\n</style>\n"],sourceRoot:""}]),e.exports=s},836:(e,t,n)=>{var r=n(15),s=n(645)(r);s.push([e.id,"\n.leader-line {\n  z-index: 0;\n}\n\n","",{version:3,sources:["webpack://./src/MarkedText.vue"],names:[],mappings:";AA+UA;EACE,UAAU;AACZ",sourcesContent:["<template>\n<p class=\"marked-text\" @mouseup=\"event => controller.onMouseUpOther(event)\">\n  <DepotRenderer\n    :spanBatches=\"spanBatches\"\n    :spanDataToStyles=\"spanDataToStyles\"\n    @trigger=\"spanDataTrigger\"\n  />\n</p>\n</template>\n\n\n\n<script lang='ts'>\nimport chroma from 'chroma-js'\nimport { Component, defineComponent, PropType } from 'vue'\n\nimport DepotRenderer from './DepotRenderer.vue'\n\nimport IMarkedText from './IMarkedText'\nimport IController from './IController'\nimport Manuscript from './Manuscript'\nimport IMark from './IMark'\nimport SpanData, { SpanControllerCbk } from './SpanData'\nimport Subject, { SubjectStyleType } from './Subject'\n\n\nconst MarkedText: Component<IMarkedText> = defineComponent({\n\n  name: 'VueMarkedText',\n\n  components: {\n    DepotRenderer\n  },\n\n  props: {\n    sourceText: {\n      type: String,\n      required: true\n    },\n    marks: {\n      type: Array as PropType<IMark[]>,\n      required: true\n    },\n    controller: {\n      type: Object as PropType<IController>,\n      required: true\n    },\n    batchSize: {\n      type: Number,\n      default: 20\n    },\n    numSubjectColors: {\n      type: Number,\n      default: 8\n    },\n    subjectColorLightness: {\n      type: Number,\n      default: 1.0\n    },\n    subjectStyleType: {\n      type: String as PropType<SubjectStyleType>,\n      default: 'border'\n    },\n    showBatches: {\n      type: Boolean,\n      default: false\n    }\n  },\n\n  data() {\n    const manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize)\n    const colors: string[] = []\n    const activeSubjectNames = new Set<string>()\n    const subjectGlossary = new Map<string, Subject>()\n    return {\n      manuscript,\n      colors,\n      activeSubjectNames,\n      subjectGlossary\n    }\n  },\n\n  computed: {\n    spanBatches(): SpanData[][] {\n      return this.manuscript.spanBatches\n    }\n  },\n\n  watch: {\n    sourceText() {\n      this.manuscript = new Manuscript(this.sourceText, this.marks, this.batchSize)\n      this.resetSpans()\n    },\n    marks: {\n      handler(newMarks: IMark[]) {\n        this.manuscript.changeMarks(newMarks)\n        this.resetSubjects()\n      },\n      deep: true\n    },\n    controller(newController: IController, oldController: IController) {\n      oldController.unlink()\n      newController.link(this)\n    },\n    batchSize(val: number) {\n      this.manuscript.batchSize = val\n      this.manuscript.resetSpans()\n    },\n    colorOptions() {\n      this.resetSubjects(false)\n      this.$forceUpdate()\n    },\n    subjectStyleType() {\n      this.resetSubjects(false)\n      this.$forceUpdate()\n    },\n    showBatches(val: boolean) {\n      if (val) this.metaStringDivideBatches()\n      else this.removeMetaStrings()\n    }\n  },\n\n  methods: {\n\n    generateColors() {\n\n      // Create a color scale with the desired brightness\n      const spectrum = chroma.scale(\n        [ 'ff0000', 'ffff00', '00ff00', '00ffff', '0000ff', 'ff00ff', 'ff0000' ].map(\n          colorStr => chroma.hex(colorStr).hsl()\n        ).map(\n          hcl => chroma.hsl(hcl[0], hcl[1], hcl[2] * this.subjectColorLightness)\n        )\n      )\n\n      let colors = spectrum.colors(this.numSubjectColors + 1).slice(0, this.numSubjectColors)\n\n      // Mix it up a bit more & get different colors earlier.\n      // Find a non-divisor to go to next color by about a 6th\n      let diff = Math.max(Math.round(colors.length / 6.0), 1)\n      while (diff > 1 && colors.length % diff === 0) diff -= 1\n      if (diff === 1) return colors\n\n      const newColors = colors.slice()\n      let idx = 0\n      for (const color of colors) {\n        newColors[idx] = color\n        idx += diff\n        if (idx >= newColors.length) idx -= newColors.length\n      }\n      return newColors\n    },\n\n    spanDataToStyles(spanData: SpanData) {\n      return spanData.subjects.map(\n        subject => this.subjectGlossary.get(subject)\n      ).filter(\n        subject => subject != null && subject.active\n      ).map(\n        subject => (subject as Subject).style\n      )\n    },\n\n    spanDataTrigger(payload: { rawEvent: Event, spanData: SpanData, spanControllerEvent: SpanControllerCbk }) {\n      payload.spanControllerEvent(payload.rawEvent, payload.spanData, this.controller)\n    },\n\n\n    resetSpans() {\n      this.manuscript.resetSpans()\n      this.resetSubjects()\n    },\n\n    resetSubjects(resetActive: boolean = true) {\n\n      this.subjectGlossary.clear()\n      const subjectNames = new Set(\n        Array<string>().concat(...this.marks.map(mark => mark.subjects))\n      )\n      let colorIdx = 0\n      const colorMod = this.colors.length\n      for (const subjectName of subjectNames) {\n        this.subjectGlossary.set(subjectName, new Subject(\n          this,\n          subjectName,\n          this.colors[colorIdx],\n          this.subjectStyleType\n        ))\n        colorIdx = (colorIdx + 1) % colorMod\n      }\n\n      if (resetActive) this.activeSubjectNames = new Set(this.subjectGlossary.keys())\n      else {\n        for (const [subjectName, subject] of this.subjectGlossary.entries()) {\n          if (!this.activeSubjectNames.has(subjectName)) subject.active = false\n        }\n      }\n\n    },\n\n\n    resetSelection() {\n      this.manuscript.selection = null\n    },\n\n    setSelection(begChar: number, endChar: number) {\n      this.manuscript.selection = [begChar, endChar]\n    },\n\n    getSelection() {\n      return this.manuscript.selection\n    },\n\n\n    subjectColor(subjectName: string) {\n      return this.subjectGlossary.get(subjectName)?.color\n    },\n    subjectStyle(subjectName: string) {\n      return this.subjectGlossary.get(subjectName)?.style\n    },\n\n    activateSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.active = true\n      this.activeSubjectNames.add(subjectName)\n      this.$forceUpdate()\n    },\n    deactivateSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.active = false\n      this.activeSubjectNames.delete(subjectName)\n      this.$forceUpdate()\n    },\n    toggleSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) {\n        if (subject.active) this.deactivateSubject(subjectName)\n        else this.activateSubject(subjectName)\n      }\n    },\n    activateAllSubjects() {\n      this.subjectGlossary.forEach(subject => { subject.active = true })\n      this.activeSubjectNames = new Set(this.subjectGlossary.keys())\n      this.$forceUpdate()\n    },\n    deactivateAllSubjects() {\n      this.subjectGlossary.forEach(subject => { subject.active = false })\n      this.activeSubjectNames = new Set()\n      this.$forceUpdate()\n    },\n\n    lineConnectSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.lineConnect()\n    },\n    lineDisconnectSubject(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.lineDisconnect()\n    },\n    toggleLines(subjectName: string) {\n      const subject = this.subjectGlossary.get(subjectName)\n      if (subject != null) subject.toggleLines()\n    },\n\n\n    metaStringEncloseSections(begSections: number[], endSections: number[]) {\n\n      const metaChars = Array(\n        ...begSections.map(idx => ['[', idx] as [string, number]),\n        ...endSections.map(idx => [']', idx] as [string, number]),\n      )\n\n      this.manuscript.setMetaStrings(metaChars)\n\n    },\n\n    metaStringDivideBatches() {\n\n      const metaChars = Array(...this.spanBatches.filter(\n        batch => batch.length > 0\n      ).map(\n        batch => ['|', batch[0].charRange[0]] as [string, number]\n      ))\n\n      this.manuscript.setMetaStrings(metaChars)\n\n    },\n\n    removeMetaStrings() {\n      this.manuscript.setMetaStrings([])\n    }\n\n  },\n\n  beforeMount() {\n    this.colors = this.generateColors()\n    this.controller.link(this)\n    this.resetSpans()\n  },\n\n  beforeUnmount() {\n    this.controller.unlink()\n  }\n\n})\n\nexport default MarkedText\n<\/script>\n\n\n\n<style scoped>\n\n.marked-text {\n  text-align: left;\n  margin-top: 30px;\n  margin-bottom: 30px;\n  margin-left: auto;\n  margin-right: auto;\n  padding: 10px 10px;\n  border-radius: 10px;\n  width: calc(90% - 2*30px - 2*10px - 2*5px);\n  height: calc(100% - 2*30px - 2*10px - 2*5px);\n  overflow-y: auto;\n  word-wrap: break-word;\n  white-space: pre-wrap;\n  position: relative;\n  z-index: 1;\n}\n\n</style>\n\n\n<style>\n\n.leader-line {\n  z-index: 0;\n}\n\n</style>\n"],sourceRoot:""}]),e.exports=s},645:e=>{"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=e(t);return t[2]?"@media ".concat(t[2]," {").concat(n,"}"):n})).join("")},t.i=function(e,n,r){"string"==typeof e&&(e=[[null,e,""]]);var s={};if(r)for(var a=0;a<this.length;a++){var o=this[a][0];null!=o&&(s[o]=!0)}for(var i=0;i<e.length;i++){var c=[].concat(e[i]);r&&s[c[0]]||(n&&(c[2]?c[2]="".concat(n," and ").concat(c[2]):c[2]=n),t.push(c))}},t}},15:e=>{"use strict";function t(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}e.exports=function(e){var n,r,s=(r=4,function(e){if(Array.isArray(e))return e}(n=e)||function(e,t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e)){var n=[],r=!0,s=!1,a=void 0;try{for(var o,i=e[Symbol.iterator]();!(r=(o=i.next()).done)&&(n.push(o.value),!t||n.length!==t);r=!0);}catch(e){s=!0,a=e}finally{try{r||null==i.return||i.return()}finally{if(s)throw a}}return n}}(n,r)||function(e,n){if(e){if("string"==typeof e)return t(e,n);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?t(e,n):void 0}}(n,r)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()),a=s[1],o=s[3];if("function"==typeof btoa){var i=btoa(unescape(encodeURIComponent(JSON.stringify(o)))),c="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(i),l="/*# ".concat(c," */"),u=o.sources.map((function(e){return"/*# sourceURL=".concat(o.sourceRoot||"").concat(e," */")}));return[a].concat(u).concat([l]).join("\n")}return[a].join("\n")}},962:(e,t,n)=>{var r=n(517);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(346).Z)("3d06991c",r,!1,{})},946:(e,t,n)=>{var r=n(836);r.__esModule&&(r=r.default),"string"==typeof r&&(r=[[e.id,r,""]]),r.locals&&(e.exports=r.locals),(0,n(346).Z)("6afb639e",r,!1,{})},346:(e,t,n)=>{"use strict";function r(e,t){for(var n=[],r={},s=0;s<t.length;s++){var a=t[s],o=a[0],i={id:e+":"+s,css:a[1],media:a[2],sourceMap:a[3]};r[o]?r[o].parts.push(i):n.push(r[o]={id:o,parts:[i]})}return n}n.d(t,{Z:()=>f});var s="undefined"!=typeof document;if("undefined"!=typeof DEBUG&&DEBUG&&!s)throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");var a={},o=s&&(document.head||document.getElementsByTagName("head")[0]),i=null,c=0,l=!1,u=function(){},h=null,p="data-vue-ssr-id",d="undefined"!=typeof navigator&&/msie [6-9]\b/.test(navigator.userAgent.toLowerCase());function f(e,t,n,s){l=n,h=s||{};var o=r(e,t);return m(o),function(t){for(var n=[],s=0;s<o.length;s++){var i=o[s];(c=a[i.id]).refs--,n.push(c)}for(t?m(o=r(e,t)):o=[],s=0;s<n.length;s++){var c;if(0===(c=n[s]).refs){for(var l=0;l<c.parts.length;l++)c.parts[l]();delete a[c.id]}}}}function m(e){for(var t=0;t<e.length;t++){var n=e[t],r=a[n.id];if(r){r.refs++;for(var s=0;s<r.parts.length;s++)r.parts[s](n.parts[s]);for(;s<n.parts.length;s++)r.parts.push(b(n.parts[s]));r.parts.length>n.parts.length&&(r.parts.length=n.parts.length)}else{var o=[];for(s=0;s<n.parts.length;s++)o.push(b(n.parts[s]));a[n.id]={id:n.id,refs:1,parts:o}}}}function y(){var e=document.createElement("style");return e.type="text/css",o.appendChild(e),e}function b(e){var t,n,r=document.querySelector("style["+p+'~="'+e.id+'"]');if(r){if(l)return u;r.parentNode.removeChild(r)}if(d){var s=c++;r=i||(i=y()),t=j.bind(null,r,s,!1),n=j.bind(null,r,s,!0)}else r=y(),t=S.bind(null,r),n=function(){r.parentNode.removeChild(r)};return t(e),function(r){if(r){if(r.css===e.css&&r.media===e.media&&r.sourceMap===e.sourceMap)return;t(e=r)}else n()}}var g,v=(g=[],function(e,t){return g[e]=t,g.filter(Boolean).join("\n")});function j(e,t,n,r){var s=n?"":r.css;if(e.styleSheet)e.styleSheet.cssText=v(t,s);else{var a=document.createTextNode(s),o=e.childNodes;o[t]&&e.removeChild(o[t]),o.length?e.insertBefore(a,o[t]):e.appendChild(a)}}function S(e,t){var n=t.css,r=t.media,s=t.sourceMap;if(r&&e.setAttribute("media",r),h.ssrId&&e.setAttribute(p,t.id),s&&(n+="\n/*# sourceURL="+s.sources[0]+" */",n+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(s))))+" */"),e.styleSheet)e.styleSheet.cssText=n;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(n))}}}},t={};function n(r){var s=t[r];if(void 0!==s)return s.exports;var a=t[r]={id:r,exports:{}};return e[r](a,a.exports,n),a.exports}n.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return n.d(t,{a:t}),t},n.d=(e,t)=>{for(var r in t)n.o(t,r)&&!n.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),n.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})};var r={};return(()=>{"use strict";n.r(r),n.d(r,{AController:()=>M,Layers:()=>x,Manuscript:()=>k,NullController:()=>B,Patch:()=>y,SpanData:()=>v,Subject:()=>N,TextSelectionController:()=>D,TypeSpanData:()=>g,WordSelectionController:()=>R,compareMarks:()=>b,createSpanData:()=>j,default:()=>A});const e=require("vue"),t=(0,e.withScopeId)("data-v-909d61e4")(((t,n,r,s,a,o)=>{const i=(0,e.resolveComponent)("DepotRenderer");return(0,e.openBlock)(),(0,e.createBlock)("p",{class:"marked-text",onMouseup:n[1]||(n[1]=e=>t.controller.onMouseUpOther(e))},[(0,e.createVNode)(i,{spanBatches:t.spanBatches,spanDataToStyles:t.spanDataToStyles,onTrigger:t.spanDataTrigger},null,8,["spanBatches","spanDataToStyles","onTrigger"])],32)})),s=require("tslib"),a=require("chroma-js");var o=n.n(a);const i=(0,e.defineComponent)({name:"BatchRenderer",props:{batch:{type:Array,required:!0},spanDataToStyles:{type:Function,required:!0}},emits:["trigger"],methods:{spanDataToCbk:function(e){var t=this;return Object.assign.apply(Object,(0,s.__spreadArray)([{}],(0,s.__read)(Object.entries(e.spanControllerEvents).map((function(n){var r,a=(0,s.__read)(n,2),o=a[0],i=a[1];return(r={})[o]=function(n){return t.$emit("trigger",{rawEvent:n,spanData:e,spanControllerEvent:i})},r})))))}}});i.render=function(t,n,r,s,a,o){return(0,e.openBlock)(!0),(0,e.createBlock)(e.Fragment,null,(0,e.renderList)(t.batch,(n=>((0,e.openBlock)(),(0,e.createBlock)("span",(0,e.mergeProps)({key:n.key,class:n.cssClasses,style:t.spanDataToStyles(n)},(0,e.toHandlers)(t.spanDataToCbk(n))),(0,e.toDisplayString)(n.text),17)))),128)};const c=i,l=(0,e.defineComponent)({name:"DepotRenderer",components:{BatchRenderer:c},props:{spanBatches:{type:Array,required:!0},spanDataToStyles:{type:Function,required:!0}},emits:["trigger"]});l.render=function(t,n,r,s,a,o){const i=(0,e.resolveComponent)("BatchRenderer");return(0,e.openBlock)(!0),(0,e.createBlock)(e.Fragment,null,(0,e.renderList)(t.spanBatches,((r,s)=>((0,e.openBlock)(),(0,e.createBlock)("span",{key:s,class:"span-batch-"+String(s)},[(0,e.createVNode)(i,{batch:r,spanDataToStyles:t.spanDataToStyles,onTrigger:n[1]||(n[1]=(...e)=>t.$emit("trigger",...e))},null,8,["batch","spanDataToStyles"])],2)))),128)};const u=l,h=require("etali"),p=require("array-sort");var d,f=n.n(p);!function(e){e[e.add=0]="add",e[e.rm=1]="rm"}(d||(d={}));var m=function(){function e(e,t){void 0===e&&(e=[]),void 0===t&&(t=[]),this.added=e,this.rmed=t}return Object.defineProperty(e.prototype,"empty",{get:function(){return 0===this.added.length&&0===this.rmed.length},enumerable:!1,configurable:!0}),e.prototype.transform=function(e){for(var t,n,r=[],a=this.rmThenAddOrder(),o=a.next();!o.done;){var i=o.value[1][0];if(o.value[0]===d.add){for(var c=[];!o.done&&o.value[1][0]===i;)c.push(o.value[1][1]),o=a.next();r.push((0,s.__spreadArray)([i,0],(0,s.__read)(c)))}else{var l=i;for(c=[];!o.done&&o.value[1][0]<=l;){switch(o.value[0]){case d.add:c.push(o.value[1][1]);break;case d.rm:l+=1}o=a.next()}r.push((0,s.__spreadArray)([i,l-i],(0,s.__read)(c)))}}try{for(var u=(0,s.__values)(r.reverse()),h=u.next();!h.done;h=u.next()){var p=h.value;e.splice.apply(e,(0,s.__spreadArray)([],(0,s.__read)(p)))}}catch(e){t={error:e}}finally{try{h&&!h.done&&(n=u.return)&&n.call(u)}finally{if(t)throw t.error}}},e.prototype.rmThenAddOrder=function(){var e,t,n,r;return(0,s.__generator)(this,(function(s){switch(s.label){case 0:e=this.added[Symbol.iterator](),t=this.rmed[Symbol.iterator](),n=e.next(),r=t.next(),s.label=1;case 1:return n.done&&r.done?[3,6]:r.done||!(n.done||r.value[0]<=n.value[0])?[3,3]:[4,[d.rm,r.value]];case 2:return s.sent(),r=t.next(),[3,5];case 3:return[4,[d.add,n.value]];case 4:s.sent(),n=e.next(),s.label=5;case 5:return[3,1];case 6:return[2]}}))},e.prototype.addThenRmOrder=function(){var e,t,n,r;return(0,s.__generator)(this,(function(s){switch(s.label){case 0:e=this.added[Symbol.iterator](),t=this.rmed[Symbol.iterator](),n=e.next(),r=t.next(),s.label=1;case 1:return n.done&&r.done?[3,6]:r.done||!(n.done||r.value[0]<n.value[0])?[3,3]:[4,[d.rm,r.value]];case 2:return s.sent(),r=t.next(),[3,5];case 3:return[4,[d.add,n.value]];case 4:s.sent(),n=e.next(),s.label=5;case 5:return[3,1];case 6:return[2]}}))},e}();const y=m;function b(e,t){return e.begChar-t.begChar||e.endChar-t.endChar||(e.text?1:0)-(t.text?1:0)||e.text&&t.text&&e.text.localeCompare(t.text)||0}var g;!function(e){e[e.Text=0]="Text",e[e.Mark=1]="Mark",e[e.Selection=2]="Selection",e[e.Meta=3]="Meta"}(g||(g={}));var v=function(){function e(e,t,n,r,s,a){this.charRange=e,this.key=t,this.cssClasses=n,this.subjects=r,this.spanControllerEvents=s,this.text=a}return e.prototype.clone=function(){return new e(this.charRange.slice(),this.key.slice(),this.cssClasses.slice(),this.subjects.slice(),this.spanControllerEvents,this.text.slice())},e}();function j(e,t){switch(e){case g.Text:return S(t.charRange,t.spanText);case g.Mark:return function(e,t,n){var r;if(null==n?void 0:n.length){var a=Array.from(new Set((r=Array()).concat.apply(r,(0,s.__spreadArray)([],(0,s.__read)(n.map((function(e){return e.subjects}))))))),o=a.map((function(e){return"mt-subject-"+e}));return new v(e,"markrange-"+e[0]+"-"+e[1],o,a,{mouseup:function(e,t,r){return r.onMouseUpMark(e,t.charRange,n)}},t)}return S(e,t)}(t.charRange,t.spanText,t.marks);case g.Selection:return n=t.charRange,r=t.spanText,new v(n,"selection-"+n[0]+"-"+n[1],["mt-selection"],[],{mouseup:function(e,t,n){return n.onMouseUpSelection(e,t.charRange)}},r);case g.Meta:return function(e,t){return new v(e,"meta-char-"+t+"-"+e[0]+"-"+e[1],["mt-meta-char"],[],{mouseup:function(e,n,r){return r.onMouseUpMetaString(e,n.charRange,t)}},t)}(t.charRange,t.spanText)}var n,r}function S(e,t){return new v(e,"text-"+e[0]+"-"+e[1],["mt-textspan"],[],{mouseup:function(e,t,n){return n.onMouseUpText(e,t.charRange)}},t)}var x=function(){function e(e,t){var n,r;this.sourceText=e,this.layerNames=[],this.layers={},this.layerPatches={},this.layerPriorities=[];try{for(var a=(0,s.__values)(t),o=a.next();!o.done;o=a.next()){var i=o.value,c=i[0];if(this.layerNames.includes(c))throw Error("Layers should not share names");this.layerNames.push(c);var l=f()(i[2].slice(),["begChar","endChar","text","subjects"]);this.layers[c]={typeSpanData:i[1],marks:l},this.layerPatches[c]=new y,this.layerPriorities.push(c)}}catch(e){n={error:e}}finally{try{o&&!o.done&&(r=a.return)&&r.call(a)}finally{if(n)throw n.error}}}return e.prototype.addLayer=function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];this.layerNames.includes(e)||(this.layerNames.push(e),this.layers[e]={typeSpanData:t,marks:[]},this.layerPatches[e]=new y,this.layerPriorities.push(e)),this.addToLayer.apply(this,(0,s.__spreadArray)([e],(0,s.__read)(n)))},e.prototype.rmLayer=function(e){this.layerNames.includes(e)&&(this.layerNames.splice(this.layerNames.indexOf(e),1),delete this.layers[e],delete this.layerPatches[e],this.layerPriorities.splice(this.layerPriorities.indexOf(e),1))},e.prototype.resetPatches=function(){var e=this;this.layerNames.forEach((function(t){e.layerPatches[t]=new y}))},Object.defineProperty(e.prototype,"length",{get:function(){return this.layerNames.length},enumerable:!1,configurable:!0}),e.prototype.layerByName=function(e){return this.layers[e]||void 0},e.prototype.getLayers=function(){return this.layers},e.prototype.patchByName=function(e){return this.layerPatches[e]},e.prototype.getPatches=function(){return this.layerPatches},e.prototype.allPatches=function(){var e=this;return this.layerNames.map((function(t){return e.layerPatches[t]}))},Object.defineProperty(e.prototype,"priorities",{get:function(){return this.layerPriorities},enumerable:!1,configurable:!0}),e.prototype.layerByPriority=function(e){if(this.layerPriorities.length<=e)throw Error("No layer priority "+e+" exists");return this.layers[this.layerPriorities[e]]},e.prototype.layersByPriority=function(){var e=this;return this.layerPriorities.map((function(t){return e.layers[t]}))},e.prototype.permutePriority=function(e){var t,n=this;if(e.length!==this.layerNames.length||!Array.from({length:e.length},(function(e,t){return t})).every((function(t){return e.includes(t)})))throw new Error("Supply valid priority permutation");(t=this.layerPriorities).splice.apply(t,(0,s.__spreadArray)([0,this.layerPriorities.length],(0,s.__read)(this.layerPriorities.map((function(t,r){return n.layerPriorities[e[r]]})))))},e.prototype.layerToFront=function(e){var t,n=this.layerPriorities.indexOf(e);if(-1===n)throw new Error("Unknown layer "+e);(t=this.layerPriorities).splice.apply(t,(0,s.__spreadArray)([0,n+1,e],(0,s.__read)(this.layerPriorities.slice(0,n))))},e.prototype.layerToBack=function(e){var t,n=this.layerPriorities.indexOf(e);if(-1===n)throw new Error("Unknown layer "+e);(t=this.layerPriorities).splice.apply(t,(0,s.__spreadArray)((0,s.__spreadArray)([n,this.layerPriorities.length-n],(0,s.__read)(this.layerPriorities.slice(n+1,this.layerPriorities.length))),[e]))},e.prototype.changeLayer=function(e,t){var n=f()(t.slice(),["begChar","endChar","text","subjects"]),r=this.patchFromDiff(this.layerByName(e).marks,n);this.layers[e].marks=n,this.mergePatch(e,r)},e.prototype.addToLayer=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=f()(t.slice(),["begChar","endChar","text","subjects"]),s=this.patchFromAdd(this.layerByName(e).marks,r);s.transform(this.layers[e].marks),this.mergePatch(e,s)},e.prototype.rmFromLayer=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=f()(t.slice(),["begChar","endChar","text","subjects"]),s=this.patchFromRm(this.layerByName(e).marks,r);s.transform(this.layers[e].marks),this.mergePatch(e,s)},e.prototype.produceSpanData=function(){var e=this.pressLayersBtwn(0,this.sourceText.length);return this.resetPatches(),e},e.prototype.patchSpanData=function(e){var t,n,r=function(e,t){for(var n=[],r=t.next(),a=void 0,o=function(){var o=r.value[1];if(e.some((function(e){return e[0]<o.charRange[1]&&o.charRange[0]<e[1]}))){var i=(0,s.__read)(o.charRange,2),c=i[0],l=i[1];a&&e.some((function(e){return e[0]===o.charRange[0]}))&&(c=a.charRange[0]),a=r.value[1],!(r=t.next()).done&&e.some((function(e){return e[1]===o.charRange[1]}))&&(l=r.value[1].charRange[1]),n.push([c,l])}else e.some((function(e){return e[0]===o.charRange[1]||o.charRange[0]===e[1]}))&&n.push(o.charRange),a=r.value[1],r=t.next()};!r.done;)o();return C(n)}(function(e){var t,n,r,a,o,i,c,l,u=[];try{for(var h=(0,s.__values)(e),p=h.next();!p.done;p=h.next()){var d=p.value;try{for(var m=(r=void 0,(0,s.__values)(d.rmThenAddOrder())),y=m.next();!y.done;y=m.next()){var b=y.value,g=[b[1][1].begChar,b[1][1].endChar],v=[];try{for(var j=(o=void 0,(0,s.__values)(u.entries())),S=j.next();!S.done;S=j.next()){var x=(0,s.__read)(S.value,2),k=x[0],w=x[1];w[0]<g[1]&&g[0]<w[1]&&v.push(k)}}catch(e){o={error:e}}finally{try{S&&!S.done&&(i=j.return)&&i.call(j)}finally{if(o)throw o.error}}var T=[g];try{for(var N=(c=void 0,(0,s.__values)(v)),_=N.next();!_.done;_=N.next())k=_.value,T.push(u.splice(k,1)[0])}catch(e){c={error:e}}finally{try{_&&!_.done&&(l=N.return)&&l.call(N)}finally{if(c)throw c.error}}u.push([Math.min.apply(Math,(0,s.__spreadArray)([],(0,s.__read)(T.map((function(e){return e[0]}))))),Math.max.apply(Math,(0,s.__spreadArray)([],(0,s.__read)(T.map((function(e){return e[1]})))))])}}catch(e){r={error:e}}finally{try{y&&!y.done&&(a=m.return)&&a.call(m)}finally{if(r)throw r.error}}}}catch(e){t={error:e}}finally{try{p&&!p.done&&(n=h.return)&&n.call(h)}finally{if(t)throw t.error}}return f()(u,(function(e,t){return e[0]-t[0]})),C(u)}(this.allPatches()),e.contentIterator()),a=new y,o=e.contentIterator(),i=o.next(),c=function(e){for(var t,n=l.pressLayersBtwn.apply(l,(0,s.__spreadArray)([],(0,s.__read)(e)));!i.done&&i.value[1].charRange[0]<e[0];)i=o.next();if(i.done)return"break";var r=i.value[0];for((t=a.added).push.apply(t,(0,s.__spreadArray)([],(0,s.__read)(n.map((function(e){return[r,e]})))));!i.done&&i.value[1].charRange[1]<=e[1];)a.rmed.push(i.value),i=o.next()},l=this;try{for(var u=(0,s.__values)(r),h=u.next();!h.done&&"break"!==c(h.value);h=u.next());}catch(e){t={error:e}}finally{try{h&&!h.done&&(n=u.return)&&n.call(u)}finally{if(t)throw t.error}}return this.resetPatches(),a},e.prototype.pressLayersBtwn=function(e,t){var n,r,a,o,i=this,c=[],l=[[e,t]],u=function(e){var t,n;if(!(null==l?void 0:l.length))return"break";var r=[],a=function(t){var n=function(){var n,r,a,o;return(0,s.__generator)(this,(function(s){switch(s.label){case 0:if(n=e.marks.findIndex((function(e){return e.endChar>t[0]})),r=e.marks.findIndex((function(e){return e.begChar>=t[1]})),-1===n)return[2];-1===r&&(r=e.marks.length),a=n,s.label=1;case 1:return a<r?[4,[(o=e.marks[a]).begChar,o.endChar,o]]:[3,4];case 2:s.sent(),s.label=3;case 3:return++a,[3,1];case 4:return[2]}}))}(),a=(0,h.FlattenRanges)(n).filter((function(e){return t[0]<e[1]&&e[0]<t[1]})).map((function(n){var r,a=(0,s.__read)([n[0],n[1]],2),o=a[0],c=a[1];t[0]>o&&(o=t[0]),t[1]<c&&(c=t[1]);var l=null===(r=n[2].find((function(e){return!!e.text})))||void 0===r?void 0:r.text;return l||(l=i.sourceText.substring(o,c)),j(e.typeSpanData,{charRange:[o,c],spanText:l,marks:n[2]})}));if(a.push.apply(a,(0,s.__spreadArray)([],(0,s.__read)(e.marks.filter((function(e){return e.begChar===e.endChar})).filter((function(e){return t[0]<=e.begChar&&e.begChar<=t[1]})).map((function(t){var n=t.text?t.text:"";return j(e.typeSpanData,{charRange:[t.begChar,t.endChar],spanText:n,marks:[t]})}))))),c.push.apply(c,(0,s.__spreadArray)([],(0,s.__read)(a))),null==a?void 0:a.length){t[0]<a[0].charRange[0]&&r.push([t[0],a[0].charRange[0]]);for(var o=0;o<a.length-1;++o){var l=a[o],u=a[o+1];l.charRange[1]<u.charRange[0]&&r.push([l.charRange[1],u.charRange[0]])}a[a.length-1].charRange[1]<t[1]&&r.push([a[a.length-1].charRange[1],t[1]])}else r.push(t)};try{for(var o=(t=void 0,(0,s.__values)(l)),u=o.next();!u.done;u=o.next())a(u.value)}catch(e){t={error:e}}finally{try{u&&!u.done&&(n=o.return)&&n.call(o)}finally{if(t)throw t.error}}l=r};try{for(var p=(0,s.__values)(this.layersByPriority()),d=p.next();!d.done&&"break"!==u(d.value);d=p.next());}catch(e){n={error:e}}finally{try{d&&!d.done&&(r=p.return)&&r.call(p)}finally{if(n)throw n.error}}f()(c,(function(e,t){return e.charRange[0]-t.charRange[0]}));var m=[],y=e;try{for(var b=(0,s.__values)(c),v=b.next();!v.done;v=b.next()){var S=v.value;y<S.charRange[0]&&m.push(j(g.Text,{charRange:[y,S.charRange[0]],spanText:this.sourceText.substring(y,S.charRange[0])})),m.push(S),y=S.charRange[1]}}catch(e){a={error:e}}finally{try{v&&!v.done&&(o=b.return)&&o.call(b)}finally{if(a)throw a.error}}return y<t&&m.push(j(g.Text,{charRange:[y,t],spanText:this.sourceText.substring(y,t)})),m},e.prototype.mergePatch=function(e,t){var n=function(e,t){for(var n=new m,r=e.rmThenAddOrder(),s=t.rmThenAddOrder(),a=r.next(),o=s.next(),i=0;!a.done||!o.done;){var c=a.done?0:a.value[1][0],l=o.done?0:o.value[1][0]+i;if(!a.done&&(o.done||c<l)){switch(a.value[0]){case d.add:i-=1,n.added.push([c,a.value[1][1]]);break;case d.rm:i+=1,n.rmed.push([c,a.value[1][1]])}a=r.next()}else if(!o.done&&(a.done||l<c)){switch(o.value[0]){case d.add:n.added.push([l,o.value[1][1]]);break;case d.rm:n.rmed.push([l,o.value[1][1]])}o=s.next()}else{var u=a.value,h=o.value,p=u[0],f=h[0];f===d.add?(n.added.push([l,h[1][1]]),o=s.next()):p===d.add?(i-=1,n.added.push([c,u[1][1]]),a=r.next()):p===d.rm?(i+=1,n.added.push([c,u[1][1]]),a=r.next()):f===d.rm&&(n.added.push([l,h[1][1]]),o=s.next())}}return n}(this.layerPatches[e],t);this.layerPatches[e]=n},e.prototype.patchFromDiff=function(e,t){for(var n=new y,r=0,s=0,a=function(){var a=e[r],o=t[s],i=b(a,o);i<0?(n.rmed.push([r,a]),++r):i>0?(n.added.push([r,o]),++s):((a.subjects.some((function(e){return!o.subjects.includes(e)}))||o.subjects.some((function(e){return!a.subjects.includes(e)})))&&(n.rmed.push([r,a]),n.added.push([r,o])),++r,++s)};r<e.length&&s<t.length;)a();for(;r<e.length;)n.rmed.push([r,e[r]]),++r;for(;s<t.length;)n.added.push([r,t[s]]),++s;return n},e.prototype.patchFromAdd=function(e,t){for(var n=new y,r=0,s=0;r<e.length&&s<t.length;){var a=e[r],o=t[s];b(a,o)>0?(n.added.push([r,o]),++s):++r}for(;s<t.length;)n.added.push([r,t[s]]),++s;return n},e.prototype.patchFromRm=function(e,t){for(var n=new y,r=0,s=0,a=function(){var a=e[r],o=t[s],i=b(a,o);0===i&&a.subjects.every((function(e){return o.subjects.includes(e)}))&&o.subjects.every((function(e){return a.subjects.includes(e)}))?(n.rmed.push([r,a]),++r,++s):i>0?(console.error("cannot find mark to remove; skipping:"),console.error(o),++s):++r};r<e.length&&s<t.length;)a();for(;s<t.length;)console.error("cannot find mark to remove; skipping:"),console.error(t[s]),++s;return n},e}();function C(e){var t,n,r=[];try{for(var a=(0,s.__values)(e),o=a.next();!o.done;o=a.next()){var i=o.value,c=r[r.length-1];c&&c[1]>=i[0]?r[r.length-1][1]=i[1]:r.push([i[0],i[1]])}}catch(e){t={error:e}}finally{try{o&&!o.done&&(n=a.return)&&n.call(a)}finally{if(t)throw t.error}}return r}const k=function(){function e(e,t,n){void 0===n&&(n=20),this.text=e,this.layers=new x(e,[["selection",g.Selection,[]],["meta",g.Meta,[]],["base",g.Mark,t]]),this.batchSize=n,this.spanBatchArray=new h.BubbleBatchArray(this.layers.produceSpanData(),this.batchSize),this.selectionCharRange=null}return Object.defineProperty(e.prototype,"baseText",{get:function(){return this.text},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"batchSize",{get:function(){return this.depotBatchSize},set:function(e){this.depotBatchSize=e},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"selection",{get:function(){return this.selectionCharRange},set:function(e){this.setSelection(e,!0)},enumerable:!1,configurable:!0}),e.prototype.setSelection=function(e,t){void 0===t&&(t=!0),this.selectionCharRange=e;var n=null==e?[]:[{begChar:e[0],endChar:e[1],subjects:[]}];this.layers.changeLayer("selection",n);var r=window.getSelection();r&&r.removeAllRanges(),t&&this.implementPatch()},Object.defineProperty(e.prototype,"spanBatches",{get:function(){return this.spanBatchArray.rawBatches},enumerable:!1,configurable:!0}),e.prototype.resetSpans=function(){this.spanBatchArray=new h.BubbleBatchArray(this.layers.produceSpanData(),this.batchSize)},e.prototype.changeMarks=function(e,t){void 0===t&&(t=!0),this.setSelection(null),this.layers.changeLayer("base",e),t&&this.implementPatch()},e.prototype.implementPatch=function(){var e=this.layers.patchSpanData(this.spanBatchArray);e.empty||e.transform(this.spanBatchArray)},e.prototype.setMetaStrings=function(e,t){void 0===t&&(t=!0);var n=e.map((function(e){return{begChar:e[1],endChar:e[1],text:e[0],subjects:[]}}));this.layers.changeLayer("meta",n),t&&this.implementPatch()},e}(),w=require("leader-line");var T=n.n(w);const N=function(){function e(e,t,n,r){void 0===r&&(r="border"),this.markedText=e,this.name=t,this.color=n,this.styleType=r,this.leaderLines=[],this.active=!0}return Object.defineProperty(e.prototype,"active",{get:function(){return this.xActive},set:function(e){this.xActive&&this.lineDisconnect(),this.xActive=e},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"style",{get:function(){var e={};return"background"===this.styleType&&(e["background-color"]=this.color,o().contrast(this.color,"#000000")>=4.5?e.color="#000000":e.color="#ffffff"),"text"===this.styleType&&(e.color=this.color),"border"===this.styleType&&(e.border="dotted 0.1em "+this.color,e["border-radius"]="5px"),"underline"===this.styleType&&(e["border-bottom"]="solid 0.1em "+this.color),e},enumerable:!1,configurable:!0}),e.prototype.lineConnect=function(){if(this.active)for(var e=1;e<this.spans.length;++e)this.leaderLines.push(new(T())(this.spans[e-1],this.spans[e],{startPlug:"square",endPlug:"square",color:this.color,path:"magnet",size:1}))},e.prototype.lineDisconnect=function(){this.leaderLines.forEach((function(e){e.remove()})),this.leaderLines=[]},e.prototype.toggleLines=function(){0===this.leaderLines.length?this.lineConnect():this.lineDisconnect()},Object.defineProperty(e.prototype,"cssClassName",{get:function(){return"mt-subject-"+this.name},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"spans",{get:function(){return Array.from(this.markedText.$el.getElementsByClassName(this.cssClassName))},enumerable:!1,configurable:!0}),e}(),_=(0,e.defineComponent)({name:"VueMarkedText",components:{DepotRenderer:u},props:{sourceText:{type:String,required:!0},marks:{type:Array,required:!0},controller:{type:Object,required:!0},batchSize:{type:Number,default:20},numSubjectColors:{type:Number,default:8},subjectColorLightness:{type:Number,default:1},subjectStyleType:{type:String,default:"border"},showBatches:{type:Boolean,default:!1}},data:function(){return{manuscript:new k(this.sourceText,this.marks,this.batchSize),colors:[],activeSubjectNames:new Set,subjectGlossary:new Map}},computed:{spanBatches:function(){return this.manuscript.spanBatches}},watch:{sourceText:function(){this.manuscript=new k(this.sourceText,this.marks,this.batchSize),this.resetSpans()},marks:{handler:function(e){this.manuscript.changeMarks(e),this.resetSubjects()},deep:!0},controller:function(e,t){t.unlink(),e.link(this)},batchSize:function(e){this.manuscript.batchSize=e,this.manuscript.resetSpans()},colorOptions:function(){this.resetSubjects(!1),this.$forceUpdate()},subjectStyleType:function(){this.resetSubjects(!1),this.$forceUpdate()},showBatches:function(e){e?this.metaStringDivideBatches():this.removeMetaStrings()}},methods:{generateColors:function(){for(var e,t,n=this,r=o().scale(["ff0000","ffff00","00ff00","00ffff","0000ff","ff00ff","ff0000"].map((function(e){return o().hex(e).hsl()})).map((function(e){return o().hsl(e[0],e[1],e[2]*n.subjectColorLightness)}))).colors(this.numSubjectColors+1).slice(0,this.numSubjectColors),a=Math.max(Math.round(r.length/6),1);a>1&&r.length%a==0;)a-=1;if(1===a)return r;var i=r.slice(),c=0;try{for(var l=(0,s.__values)(r),u=l.next();!u.done;u=l.next()){var h=u.value;i[c]=h,(c+=a)>=i.length&&(c-=i.length)}}catch(t){e={error:t}}finally{try{u&&!u.done&&(t=l.return)&&t.call(l)}finally{if(e)throw e.error}}return i},spanDataToStyles:function(e){var t=this;return e.subjects.map((function(e){return t.subjectGlossary.get(e)})).filter((function(e){return null!=e&&e.active})).map((function(e){return e.style}))},spanDataTrigger:function(e){e.spanControllerEvent(e.rawEvent,e.spanData,this.controller)},resetSpans:function(){this.manuscript.resetSpans(),this.resetSubjects()},resetSubjects:function(e){var t,n,r,a,o;void 0===e&&(e=!0),this.subjectGlossary.clear();var i=new Set((t=Array()).concat.apply(t,(0,s.__spreadArray)([],(0,s.__read)(this.marks.map((function(e){return e.subjects})))))),c=0,l=this.colors.length;try{for(var u=(0,s.__values)(i),h=u.next();!h.done;h=u.next()){var p=h.value;this.subjectGlossary.set(p,new N(this,p,this.colors[c],this.subjectStyleType)),c=(c+1)%l}}catch(e){n={error:e}}finally{try{h&&!h.done&&(r=u.return)&&r.call(u)}finally{if(n)throw n.error}}if(e)this.activeSubjectNames=new Set(this.subjectGlossary.keys());else try{for(var d=(0,s.__values)(this.subjectGlossary.entries()),f=d.next();!f.done;f=d.next()){var m=(0,s.__read)(f.value,2),y=(p=m[0],m[1]);this.activeSubjectNames.has(p)||(y.active=!1)}}catch(e){a={error:e}}finally{try{f&&!f.done&&(o=d.return)&&o.call(d)}finally{if(a)throw a.error}}},resetSelection:function(){this.manuscript.selection=null},setSelection:function(e,t){this.manuscript.selection=[e,t]},getSelection:function(){return this.manuscript.selection},subjectColor:function(e){var t;return null===(t=this.subjectGlossary.get(e))||void 0===t?void 0:t.color},subjectStyle:function(e){var t;return null===(t=this.subjectGlossary.get(e))||void 0===t?void 0:t.style},activateSubject:function(e){var t=this.subjectGlossary.get(e);null!=t&&(t.active=!0),this.activeSubjectNames.add(e),this.$forceUpdate()},deactivateSubject:function(e){var t=this.subjectGlossary.get(e);null!=t&&(t.active=!1),this.activeSubjectNames.delete(e),this.$forceUpdate()},toggleSubject:function(e){var t=this.subjectGlossary.get(e);null!=t&&(t.active?this.deactivateSubject(e):this.activateSubject(e))},activateAllSubjects:function(){this.subjectGlossary.forEach((function(e){e.active=!0})),this.activeSubjectNames=new Set(this.subjectGlossary.keys()),this.$forceUpdate()},deactivateAllSubjects:function(){this.subjectGlossary.forEach((function(e){e.active=!1})),this.activeSubjectNames=new Set,this.$forceUpdate()},lineConnectSubject:function(e){var t=this.subjectGlossary.get(e);null!=t&&t.lineConnect()},lineDisconnectSubject:function(e){var t=this.subjectGlossary.get(e);null!=t&&t.lineDisconnect()},toggleLines:function(e){var t=this.subjectGlossary.get(e);null!=t&&t.toggleLines()},metaStringEncloseSections:function(e,t){var n=Array.apply(void 0,(0,s.__spreadArray)((0,s.__spreadArray)([],(0,s.__read)(e.map((function(e){return["[",e]})))),(0,s.__read)(t.map((function(e){return["]",e]})))));this.manuscript.setMetaStrings(n)},metaStringDivideBatches:function(){var e=Array.apply(void 0,(0,s.__spreadArray)([],(0,s.__read)(this.spanBatches.filter((function(e){return e.length>0})).map((function(e){return["|",e[0].charRange[0]]})))));this.manuscript.setMetaStrings(e)},removeMetaStrings:function(){this.manuscript.setMetaStrings([])}},beforeMount:function(){this.colors=this.generateColors(),this.controller.link(this),this.resetSpans()},beforeUnmount:function(){this.controller.unlink()}});n(962),n(946),_.render=t,_.__scopeId="data-v-909d61e4";const A=_;var M=function(){function e(){this.markedText=null}return e.prototype.link=function(e){this.markedText!==e&&(this.deselect(),this.markedText=e)},e.prototype.unlink=function(){null!=this.markedText&&(this.deselect(),this.markedText=null)},e}(),B=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return(0,s.__extends)(t,e),t.prototype.deselect=function(){},t.prototype.selectNew=function(){},t.prototype.selectMarks=function(e){},t.prototype.onMouseUpText=function(){},t.prototype.onMouseUpMark=function(){},t.prototype.onMouseUpSelection=function(){},t.prototype.onMouseUpMetaString=function(){},t.prototype.onMouseUpOther=function(){},t}(M),D=function(e){function t(t,n,r){var s=e.call(this)||this;return s.deselectCbk=t,s.selectNewCbk=n,s.selectMarksCbk=r,s}return(0,s.__extends)(t,e),t.prototype.deselect=function(){this.markedText&&this.markedText.resetSelection(),this.deselectCbk()},t.prototype.selectNew=function(e,t){this.markedText&&this.markedText.setSelection(e,t),this.selectNewCbk(e,t)},t.prototype.selectMarks=function(e){this.markedText&&(1===e.length?this.markedText.setSelection(e[0].begChar,e[0].endChar):this.markedText.resetSelection()),this.selectMarksCbk(e)},t.prototype.onMouseUpText=function(e,t){e.stopPropagation();var n=window.getSelection();if(n){if(!(n.anchorNode instanceof Text&&n.focusNode instanceof Text))return console.error("Window selection behaving strangely; anchor or focus not a Text."),void this.deselect();var r=!1,s=document.createRange();s.setStart(n.anchorNode,n.anchorOffset),s.setEnd(n.focusNode,n.focusOffset),1!==s.compareBoundaryPoints(Range.START_TO_END,s)&&(r=!0,s.setStart(n.focusNode,n.focusOffset),s.setEnd(n.anchorNode,n.anchorOffset)),0===s.toString().length&&n.focusNode.length>n.focusOffset&&s.setEnd(s.endContainer,s.endOffset+1);var a=s.startOffset,o=s.endOffset,i=s.toString().length;r?o=(a+=t[0])+i:a=(o+=t[0])-i,this.selectNew(a,o)}},t.prototype.onMouseUpMark=function(e,t,n){e.stopPropagation();var r=window.getSelection();if(r)if(0===r.getRangeAt(0).toString().length){for(var s=document.createRange(),a=e.target;!(a instanceof Text);)a=a.childNodes[0];s.setStart(a,0);for(var o=e.target;!(o instanceof Text);){var i=o.childNodes;o=i[i.length-1]}s.setEnd(o,o.length),this.selectMarks(n)}else this.onMouseUpText(e,t)},t.prototype.onMouseUpSelection=function(e,t){e.stopPropagation()},t.prototype.onMouseUpMetaString=function(e,t,n){e.stopPropagation()},t.prototype.onMouseUpOther=function(e){e.stopPropagation(),this.deselect()},t}(M),R=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return(0,s.__extends)(t,e),t.prototype.onMouseUpText=function(e,t){e.stopPropagation();var n=window.getSelection();if(n){if(!(n.anchorNode instanceof Text&&n.focusNode instanceof Text))return console.error("Window selection behaving strangely; anchor or focus not a Text."),void this.deselect();var r=!1,s=document.createRange();s.setStart(n.anchorNode,n.anchorOffset),s.setEnd(n.focusNode,n.focusOffset),1!==s.compareBoundaryPoints(Range.START_TO_END,s)&&(r=!0,s.setStart(n.focusNode,n.focusOffset),s.setEnd(n.anchorNode,n.anchorOffset)),0===s.toString().length&&n.focusNode.length>n.focusOffset&&s.setEnd(s.endContainer,s.endOffset+1);var a=s.toString();if(/\S/.test(a)){var o,i;if(/\s/.test(a[0]))o=a.search(/(\S)/)+s.startOffset;else{var c=document.createRange();c.setStart(s.startContainer,0),c.setEnd(s.startContainer,s.startOffset),o=c.toString().search(/([^\w\d])[\w\d]*$/)+1}if(/\s/.test(a[a.length-1]))(i=a.search(/(\S)\s*$/)+s.endOffset-a.length+1)<0&&(i=0);else{var l=document.createRange();l.setStart(s.endContainer,s.endOffset),l.setEnd(s.endContainer,s.endContainer.length),-1===(i=l.toString().search(/([^\w\d])/))?i=s.endContainer.length:i+=s.endOffset}s.setStart(s.startContainer,o),s.setEnd(s.endContainer,i),n.removeAllRanges(),n.addRange(s);var u=s.toString().length;r?i=(o+=t[0])+u:o=(i+=t[0])-u,this.selectNew(o,i)}else this.deselect()}},t}(D)})(),r})()}));
//# sourceMappingURL=vue-mark-text.js.map